var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { forwardRef } from "react";
import cn from "classnames";
import { bem } from "@react-md/utils";
var block = bem("rmd-dialog");
/**
 * This component adds some base styles to an `<h2>` element for a title within
 * a `Dialog`.
 */
var DialogTitle = function (_a) {
    var children = _a.children, className = _a.className, forwardedRef = _a.forwardedRef, props = __rest(_a, ["children", "className", "forwardedRef"]);
    return (React.createElement("h2", __assign({}, props, { className: cn(block("title"), className), ref: forwardedRef }), children));
};
if (process.env.NODE_ENV !== "production") {
    DialogTitle.displayName = "DialogTitle";
    var PropTypes = null;
    try {
        PropTypes = require("prop-types");
    }
    catch (e) { }
    if (PropTypes) {
        DialogTitle.propTypes = {
            className: PropTypes.string,
            children: PropTypes.node,
            forwardedRef: PropTypes.oneOfType([PropTypes.func, PropTypes.object]),
        };
    }
}
export default forwardRef(function (props, ref) { return React.createElement(DialogTitle, __assign({}, props, { forwardedRef: ref })); });
//# sourceMappingURL=DialogTitle.js.map