var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { forwardRef } from "react";
import cn from "classnames";
import { useFixedPositioning, } from "@react-md/transition";
import Dialog from "./Dialog";
/**
 * The `FixedDialog` is a wrapper for the `Dialog` component that can be used
 * to be fix itself to another element. Another term for this component might
 * be a "Pop out Dialog".
 */
var FixedDialog = function (providedProps) {
    var _a = providedProps, fixedTo = _a.fixedTo, anchor = _a.anchor, options = _a.options, getOptions = _a.getOptions, forwardedRef = _a.forwardedRef, children = _a.children, className = _a.className, props = __rest(_a, ["fixedTo", "anchor", "options", "getOptions", "forwardedRef", "children", "className"]);
    var onRequestClose = props.onRequestClose;
    var _b = useFixedPositioning(__assign(__assign({ transformOrigin: true }, options), { onScroll: function (_event, _a) {
            var visible = _a.visible;
            if (!visible) {
                onRequestClose();
            }
        }, fixedTo: fixedTo,
        anchor: anchor,
        getOptions: getOptions })), style = _b.style, onEnter = _b.onEnter, onEntering = _b.onEntering, onEntered = _b.onEntered, onExited = _b.onExited;
    return (React.createElement(Dialog, __assign({}, props, { className: cn("rmd-dialog--fixed", className), type: "custom", ref: forwardedRef, style: style, onEnter: onEnter, onEntering: onEntering, onEntered: onEntered, onExited: onExited }), children));
};
var defaultProps = {
    anchor: {
        x: "inner-right",
        y: "top",
    },
    classNames: {
        appear: "rmd-dialog--fixed-enter",
        appearActive: "rmd-dialog--fixed-enter-active",
        enter: "rmd-dialog--fixed-enter",
        enterActive: "rmd-dialog--fixed-enter-active",
        exit: "rmd-dialog--fixed-exit",
        exitActive: "rmd-dialog--fixed-exit-active",
    },
    overlayHidden: true,
    disableScrollLock: true,
};
FixedDialog.defaultProps = defaultProps;
if (process.env.NODE_ENV !== "production") {
    FixedDialog.displayName = "FixedDialog";
    var PropTypes = null;
    try {
        PropTypes = require("prop-types");
    }
    catch (e) { }
    if (PropTypes) {
        FixedDialog.propTypes = {
            fixedTo: PropTypes.oneOfType([
                PropTypes.string,
                PropTypes.func,
                PropTypes.object,
            ]),
            options: PropTypes.shape({
                vwMargin: PropTypes.number,
                vhMargin: PropTypes.number,
                xMargin: PropTypes.number,
                yMargin: PropTypes.number,
                disableSwapping: PropTypes.bool,
                transformOrigin: PropTypes.bool,
            }),
            getOptions: PropTypes.func,
            onRequestClose: PropTypes.func.isRequired,
            overlayHidden: PropTypes.bool,
            classNames: PropTypes.oneOfType([
                PropTypes.string,
                PropTypes.shape({
                    appear: PropTypes.string,
                    appearActive: PropTypes.string,
                    enter: PropTypes.string,
                    enterActive: PropTypes.string,
                    enterDone: PropTypes.string,
                    exit: PropTypes.string,
                    exitActive: PropTypes.string,
                    exitDone: PropTypes.string,
                }),
            ]),
            timeout: PropTypes.oneOfType([
                PropTypes.number,
                PropTypes.shape({
                    enter: PropTypes.number,
                    exit: PropTypes.number,
                }),
            ]),
            disableScrollLock: PropTypes.bool,
            anchor: PropTypes.shape({
                x: PropTypes.oneOf([
                    "inner-left",
                    "inner-right",
                    "center",
                    "left",
                    "right",
                ]),
                y: PropTypes.oneOf(["above", "below", "center", "top", "bottom"]),
            }),
        };
    }
}
export default forwardRef(function (props, ref) { return (React.createElement(FixedDialog, __assign({}, props, { forwardedRef: ref }))); });
//# sourceMappingURL=FixedDialog.js.map